####################################
#
#  WikipediaAppController.rb
#
#  Created by Heiko Kretschmer on 2010.
#  Copyright (c) 2010 Heiko Kretschmer. All rights reserved.
#

####################################
# Requirements
require 'osx/cocoa'

############################################################################################################
# DEBUG Settings!				   #                                                                       #
DEBUGAPPCONTROLLER			= TRUE  # -> Set this before deployment to FALSE! <-						   #
############################################################################################################

####################################
# Class "WikipediaAppController"   # 
class WikipediaAppController < OSX::NSObject

####################################
# Includes						   #
include		OSX

####################################
# Outlets                          #
ib_outlets :window, :webView
 
####################################
# Globals                          #
$globals = Hash.new

####################################
# Methoden                         #

# AwakeFromNib
def awakeFromNib
	Say("AppCrt: Awaking from nib.")

	# Preferences lesen
#	Say("AppCrt: Reading preferences...")
#	preferencesRead()
	
	# Preferences in window anzeigen
#	Say("AppCrt: Applying preferences...")
#	preferencesApply()
	
end # of awakeFromNib

def applicationDidBecomeActive(aNotification)
	Say("didActivate!")
#	self.addKeyboardShortCutsToScriptsMenu($globals ["scriptsMenuInStatusMenu"], true)
	@window.makeKeyAndOrderFront_(self)
end # didActivate

def applicationWillResignActive(aNotification)
	Say("willDeactivate!")
#	self.addKeyboardShortCutsToScriptsMenu($globals ["scriptsMenuInStatusMenu"], false)
end # didDeactivate
	
# About Window
#def aboutApp (sender)
#    thisBundle = OSX::NSBundle.mainBundle
#	copyrightString = thisBundle.objectForInfoDictionaryKey("CFBundleGetInfoString")
#	versionString   = thisBundle.objectForInfoDictionaryKey("VersionString")
#	NSApp.orderFrontStandardAboutPanelWithOptions("Copyright" => copyrightString, "ApplicationVersion" => versionString)
#end # aboutApp 
#ib_action :aboutApp

def applicationDidFinishLaunching(notification)
	Say("Application finished launching")
end

# If sent to foreground
def sendToForeground(sender)
	Say("Application coming to front")
	OSX::NSApp.activateIgnoringOtherApps:YES # Verfahren aus Schick geklaut
end

# Will Terminate
def applicationWillTerminate (notification)
	Say("Will terminate.")
end

# Should Terminate
def applicationShouldTerminate (notification)
	Say("Should terminate.")
	#	preferencesWrite()
	return NSTerminateNow
end


###############################################################################
# Private API #################################################################
private
def Say(*args)
    if (DEBUGAPPCONTROLLER==0) then return # Debugging ist aus -> raus hier
#    if ($globals['debug'].to_i==0) then return # Debugging ist aus -> raus hier
	else
		OSX::NSLog(*args)
	end # else !debug
end # Say
  
end # AppController
